/*
  Register definitions for slave core: FMC masterFIP core registers

  * File           : mf_regs.h
  * Author         : auto-generated by wbgen2 from fmc_masterfip_csr.wb
  * Created        : Tue Aug 11 15:25:40 2015
  * Standard       : ANSI C

    THIS FILE WAS GENERATED BY wbgen2 FROM SOURCE FILE fmc_masterfip_csr.wb
    DO NOT HAND-EDIT UNLESS IT'S ABSOLUTELY NECESSARY!

*/

#ifndef __WBGEN2_REGDEFS_FMC_MASTERFIP_CSR_WB
#define __WBGEN2_REGDEFS_FMC_MASTERFIP_CSR_WB

#include <inttypes.h>

#if defined( __GNUC__)
#define PACKED __attribute__ ((packed))
#else
#error "Unsupported compiler?"
#endif

#ifndef __WBGEN2_MACROS_DEFINED__
#define __WBGEN2_MACROS_DEFINED__
#define WBGEN2_GEN_MASK(offset, size) (((1<<(size))-1) << (offset))
#define WBGEN2_GEN_WRITE(value, offset, size) (((value) & ((1<<(size))-1)) << (offset))
#define WBGEN2_GEN_READ(reg, offset, size) (((reg) >> (offset)) & ((1<<(size))-1))
#define WBGEN2_SIGN_EXTEND(value, bits) (((value) & (1<<bits) ? ~((1<<(bits))-1): 0 ) | (value))
#endif


/* definitions for register: Reset Register */

/* definitions for field: reset of the masterFIP core in reg: Reset Register */
#define MF_RST_CORE                           WBGEN2_GEN_MASK(0, 1)

/* definitions for field: reset of the fieldrive chip (FD_RSTN) in reg: Reset Register */
#define MF_RST_FD                             WBGEN2_GEN_MASK(1, 1)

/* definitions for field: reset magic value in reg: Reset Register */
#define MF_RST_LOCK_MASK                      WBGEN2_GEN_MASK(16, 16)
#define MF_RST_LOCK_SHIFT                     16
#define MF_RST_LOCK_W(value)                  WBGEN2_GEN_WRITE(value, 16, 16)
#define MF_RST_LOCK_R(reg)                    WBGEN2_GEN_READ(reg, 16, 16)

/* definitions for register: Identification Register */

/* definitions for register: config from host */

/* definitions for field: speed in reg: config from host */
#define MF_CONFIG_HOST_SPEED_MASK             WBGEN2_GEN_MASK(0, 2)
#define MF_CONFIG_HOST_SPEED_SHIFT            0
#define MF_CONFIG_HOST_SPEED_W(value)         WBGEN2_GEN_WRITE(value, 0, 2)
#define MF_CONFIG_HOST_SPEED_R(reg)           WBGEN2_GEN_READ(reg, 0, 2)

/* definitions for field: termination enable on the external synch input in reg: config from host */
#define MF_CONFIG_HOST_EXT_SYNC_TERM_EN_N     WBGEN2_GEN_MASK(2, 1)

/* definitions for field: station address in reg: config from host */
#define MF_CONFIG_HOST_SUBS_MASK              WBGEN2_GEN_MASK(8, 8)
#define MF_CONFIG_HOST_SUBS_SHIFT             8
#define MF_CONFIG_HOST_SUBS_W(value)          WBGEN2_GEN_WRITE(value, 8, 8)
#define MF_CONFIG_HOST_SUBS_R(reg)            WBGEN2_GEN_READ(reg, 8, 8)

/* definitions for register: config from fmc */

/* definitions for field: speed in reg: config from fmc */
#define MF_CONFIG_FMC_SPEED_MASK              WBGEN2_GEN_MASK(0, 2)
#define MF_CONFIG_FMC_SPEED_SHIFT             0
#define MF_CONFIG_FMC_SPEED_W(value)          WBGEN2_GEN_WRITE(value, 0, 2)
#define MF_CONFIG_FMC_SPEED_R(reg)            WBGEN2_GEN_READ(reg, 0, 2)

/* definitions for field: speed match in reg: config from fmc */
#define MF_CONFIG_FMC_SPEED_OK                WBGEN2_GEN_MASK(31, 1)

/* definitions for register: Macrocycle Length Register */

/* definitions for field: macrocycle lgth in reg: Macrocycle Length Register */
#define MF_MACROCYC_LGTH_MASK                 WBGEN2_GEN_MASK(0, 31)
#define MF_MACROCYC_LGTH_SHIFT                0
#define MF_MACROCYC_LGTH_W(value)             WBGEN2_GEN_WRITE(value, 0, 31)
#define MF_MACROCYC_LGTH_R(reg)               WBGEN2_GEN_READ(reg, 0, 31)

/* definitions for field: macrocycle cnt start in reg: Macrocycle Length Register */
#define MF_MACROCYC_START                     WBGEN2_GEN_MASK(31, 1)

/* definitions for register: Turnaround Length Register */

/* definitions for field: turnaround time in reg: Turnaround Length Register */
#define MF_TURNAR_LGTH_MASK                   WBGEN2_GEN_MASK(0, 31)
#define MF_TURNAR_LGTH_SHIFT                  0
#define MF_TURNAR_LGTH_W(value)               WBGEN2_GEN_WRITE(value, 0, 31)
#define MF_TURNAR_LGTH_R(reg)                 WBGEN2_GEN_READ(reg, 0, 31)

/* definitions for field: turnaround cnt start in reg: Turnaround Length Register */
#define MF_TURNAR_START                       WBGEN2_GEN_MASK(31, 1)

/* definitions for register: Silence Length Register */

/* definitions for field: silence time in reg: Silence Length Register */
#define MF_SILEN_LGTH_MASK                    WBGEN2_GEN_MASK(0, 31)
#define MF_SILEN_LGTH_SHIFT                   0
#define MF_SILEN_LGTH_W(value)                WBGEN2_GEN_WRITE(value, 0, 31)
#define MF_SILEN_LGTH_R(reg)                  WBGEN2_GEN_READ(reg, 0, 31)

/* definitions for field: silence cnt start in reg: Silence Length Register */
#define MF_SILEN_START                        WBGEN2_GEN_MASK(31, 1)

/* definitions for register: Macrocycle Time Counter */

/* definitions for register: Turnaround Time Counter */

/* definitions for register: Silence Time Counter */

/* definitions for register: External Sync Timestamp */

/* definitions for register: TC Control Register */

/* definitions for field: tx rst in reg: TC Control Register */
#define MF_TX_CTRL_RST                        WBGEN2_GEN_MASK(0, 1)

/* definitions for field: tx strt in reg: TC Control Register */
#define MF_TX_CTRL_START                      WBGEN2_GEN_MASK(1, 1)

/* definitions for field: tx number of bytes in reg: TC Control Register */
#define MF_TX_CTRL_BYTES_NUM_MASK             WBGEN2_GEN_MASK(8, 9)
#define MF_TX_CTRL_BYTES_NUM_SHIFT            8
#define MF_TX_CTRL_BYTES_NUM_W(value)         WBGEN2_GEN_WRITE(value, 8, 9)
#define MF_TX_CTRL_BYTES_NUM_R(reg)           WBGEN2_GEN_READ(reg, 8, 9)

/* definitions for register: TX Status Register */

/* definitions for field: tx stopped in reg: TX Status Register */
#define MF_TX_STATUS_STOP                     WBGEN2_GEN_MASK(0, 1)

/* definitions for register: FielDrive Status Register */

/* definitions for field: fd watchdog in reg: FielDrive Status Register */
#define MF_FD_STATUS_WDGN                     WBGEN2_GEN_MASK(0, 1)

/* definitions for field: fd transmitter error in reg: FielDrive Status Register */
#define MF_FD_STATUS_TXER                     WBGEN2_GEN_MASK(1, 1)

/* definitions for register: RX Control */

/* definitions for field: rx rst in reg: RX Control */
#define MF_RX_CTRL_RST                        WBGEN2_GEN_MASK(0, 1)

/* definitions for register: RX Status */

/* definitions for field: rx preamble detected in reg: RX Status */
#define MF_RX_STATUS_PREAM_OK                 WBGEN2_GEN_MASK(0, 1)

/* definitions for field: rx frame ok in reg: RX Status */
#define MF_RX_STATUS_FRAME_OK                 WBGEN2_GEN_MASK(1, 1)

/* definitions for field: rx frame error in reg: RX Status */
#define MF_RX_STATUS_FRAME_ERR                WBGEN2_GEN_MASK(2, 1)

/* definitions for field: rx frame error code in reg: RX Status */
#define MF_RX_STATUS_FRAME_ERR_CODE_MASK      WBGEN2_GEN_MASK(3, 3)
#define MF_RX_STATUS_FRAME_ERR_CODE_SHIFT     3
#define MF_RX_STATUS_FRAME_ERR_CODE_W(value)  WBGEN2_GEN_WRITE(value, 3, 3)
#define MF_RX_STATUS_FRAME_ERR_CODE_R(reg)    WBGEN2_GEN_READ(reg, 3, 3)

/* definitions for field: rx number of data bytes in reg: RX Status */
#define MF_RX_STATUS_BYTES_NUM_MASK           WBGEN2_GEN_MASK(8, 9)
#define MF_RX_STATUS_BYTES_NUM_SHIFT          8
#define MF_RX_STATUS_BYTES_NUM_W(value)       WBGEN2_GEN_WRITE(value, 8, 9)
#define MF_RX_STATUS_BYTES_NUM_R(reg)         WBGEN2_GEN_READ(reg, 8, 9)

/* definitions for register: RX Control Byte */

/* definitions for register: rx data reg1 */

/* definitions for register: rx data reg2 */

/* definitions for register: rx data reg3 */

/* definitions for register: rx data reg4 */

/* definitions for register: rx data reg5 */

/* definitions for register: rx data reg6 */

/* definitions for register: rx data reg7 */

/* definitions for register: rx data reg8 */

/* definitions for register: rx data reg9 */

/* definitions for register: rx data reg10 */

/* definitions for register: rx data reg11 */

/* definitions for register: rx data reg12 */

/* definitions for register: rx data reg13 */

/* definitions for register: rx data reg14 */

/* definitions for register: rx data reg15 */

/* definitions for register: rx data reg16 */

/* definitions for register: rx data reg17 */

/* definitions for register: rx data reg18 */

/* definitions for register: rx data reg19 */

/* definitions for register: rx data reg20 */

/* definitions for register: rx data reg21 */

/* definitions for register: rx data reg22 */

/* definitions for register: rx data reg23 */

/* definitions for register: rx data reg24 */

/* definitions for register: rx data reg25 */

/* definitions for register: rx data reg26 */

/* definitions for register: rx data reg27 */

/* definitions for register: rx data reg28 */

/* definitions for register: rx data reg29 */

/* definitions for register: rx data reg30 */

/* definitions for register: rx data reg31 */

/* definitions for register: rx data reg32 */

/* definitions for register: TX Control Byte */

/* definitions for register: tx data reg1 */

/* definitions for register: tx data reg2 */

/* definitions for register: tx data reg3 */

/* definitions for register: tx data reg4 */

/* definitions for register: tx data reg5 */

/* definitions for register: tx data reg6 */

/* definitions for register: tx data reg7 */

/* definitions for register: tx data reg8 */

/* definitions for register: tx data reg9 */

/* definitions for register: tx data reg10 */

/* definitions for register: tx data reg11 */

/* definitions for register: tx data reg12 */

/* definitions for register: tx data reg13 */

/* definitions for register: tx data reg14 */

/* definitions for register: tx data reg15 */

/* definitions for register: tx data reg16 */

/* definitions for register: tx data reg17 */

/* definitions for register: tx data reg18 */

/* definitions for register: tx data reg19 */

/* definitions for register: tx data reg20 */

/* definitions for register: tx data reg21 */

/* definitions for register: tx data reg22 */

/* definitions for register: tx data reg23 */

/* definitions for register: tx data reg24 */

/* definitions for register: tx data reg25 */

/* definitions for register: tx data reg26 */

/* definitions for register: tx data reg27 */

/* definitions for register: tx data reg28 */

/* definitions for register: tx data reg29 */

/* definitions for register: tx data reg30 */

/* definitions for register: tx data reg31 */

/* definitions for register: tx data reg32 */
/* [0x0]: REG Reset Register */
#define MF_REG_RSTN 0x00000000
/* [0x4]: REG Identification Register */
#define MF_REG_ID 0x00000004
/* [0x8]: REG config from host */
#define MF_REG_CONFIG_HOST 0x00000008
/* [0xc]: REG config from fmc */
#define MF_REG_CONFIG_FMC 0x0000000c
/* [0x10]: REG Macrocycle Length Register */
#define MF_REG_MACROCYC 0x00000010
/* [0x14]: REG Turnaround Length Register */
#define MF_REG_TURNAR 0x00000014
/* [0x18]: REG Silence Length Register */
#define MF_REG_SILEN 0x00000018
/* [0x1c]: REG Macrocycle Time Counter */
#define MF_REG_MACROCYC_TIME_CNT 0x0000001c
/* [0x20]: REG Turnaround Time Counter */
#define MF_REG_TURNAR_TIME_CNT 0x00000020
/* [0x24]: REG Silence Time Counter */
#define MF_REG_SILEN_TIME_CNT 0x00000024
/* [0x28]: REG External Sync Timestamp */
#define MF_REG_EXT_SYNC_TSTAMP 0x00000028
/* [0x2c]: REG TC Control Register */
#define MF_REG_TX_CTRL 0x0000002c
/* [0x30]: REG TX Status Register */
#define MF_REG_TX_STATUS 0x00000030
/* [0x34]: REG FielDrive Status Register */
#define MF_REG_FD_STATUS 0x00000034
/* [0x38]: REG RX Control */
#define MF_REG_RX_CTRL 0x00000038
/* [0x3c]: REG RX Status */
#define MF_REG_RX_STATUS 0x0000003c
/* [0x40]: REG RX Control Byte */
#define MF_REG_RX_DATA_CTRL 0x00000040
/* [0x44]: REG rx data reg1 */
#define MF_REG_RX_DATA_REG1 0x00000044
/* [0x48]: REG rx data reg2 */
#define MF_REG_RX_DATA_REG2 0x00000048
/* [0x4c]: REG rx data reg3 */
#define MF_REG_RX_DATA_REG3 0x0000004c
/* [0x50]: REG rx data reg4 */
#define MF_REG_RX_DATA_REG4 0x00000050
/* [0x54]: REG rx data reg5 */
#define MF_REG_RX_DATA_REG5 0x00000054
/* [0x58]: REG rx data reg6 */
#define MF_REG_RX_DATA_REG6 0x00000058
/* [0x5c]: REG rx data reg7 */
#define MF_REG_RX_DATA_REG7 0x0000005c
/* [0x60]: REG rx data reg8 */
#define MF_REG_RX_DATA_REG8 0x00000060
/* [0x64]: REG rx data reg9 */
#define MF_REG_RX_DATA_REG9 0x00000064
/* [0x68]: REG rx data reg10 */
#define MF_REG_RX_DATA_REG10 0x00000068
/* [0x6c]: REG rx data reg11 */
#define MF_REG_RX_DATA_REG11 0x0000006c
/* [0x70]: REG rx data reg12 */
#define MF_REG_RX_DATA_REG12 0x00000070
/* [0x74]: REG rx data reg13 */
#define MF_REG_RX_DATA_REG13 0x00000074
/* [0x78]: REG rx data reg14 */
#define MF_REG_RX_DATA_REG14 0x00000078
/* [0x7c]: REG rx data reg15 */
#define MF_REG_RX_DATA_REG15 0x0000007c
/* [0x80]: REG rx data reg16 */
#define MF_REG_RX_DATA_REG16 0x00000080
/* [0x84]: REG rx data reg17 */
#define MF_REG_RX_DATA_REG17 0x00000084
/* [0x88]: REG rx data reg18 */
#define MF_REG_RX_DATA_REG18 0x00000088
/* [0x8c]: REG rx data reg19 */
#define MF_REG_RX_DATA_REG19 0x0000008c
/* [0x90]: REG rx data reg20 */
#define MF_REG_RX_DATA_REG20 0x00000090
/* [0x94]: REG rx data reg21 */
#define MF_REG_RX_DATA_REG21 0x00000094
/* [0x98]: REG rx data reg22 */
#define MF_REG_RX_DATA_REG22 0x00000098
/* [0x9c]: REG rx data reg23 */
#define MF_REG_RX_DATA_REG23 0x0000009c
/* [0xa0]: REG rx data reg24 */
#define MF_REG_RX_DATA_REG24 0x000000a0
/* [0xa4]: REG rx data reg25 */
#define MF_REG_RX_DATA_REG25 0x000000a4
/* [0xa8]: REG rx data reg26 */
#define MF_REG_RX_DATA_REG26 0x000000a8
/* [0xac]: REG rx data reg27 */
#define MF_REG_RX_DATA_REG27 0x000000ac
/* [0xb0]: REG rx data reg28 */
#define MF_REG_RX_DATA_REG28 0x000000b0
/* [0xb4]: REG rx data reg29 */
#define MF_REG_RX_DATA_REG29 0x000000b4
/* [0xb8]: REG rx data reg30 */
#define MF_REG_RX_DATA_REG30 0x000000b8
/* [0xbc]: REG rx data reg31 */
#define MF_REG_RX_DATA_REG31 0x000000bc
/* [0xc0]: REG rx data reg32 */
#define MF_REG_RX_DATA_REG32 0x000000c0
/* [0xc4]: REG TX Control Byte */
#define MF_REG_TX_DATA_CTRL 0x000000c4
/* [0xc8]: REG tx data reg1 */
#define MF_REG_TX_DATA_REG1 0x000000c8
/* [0xcc]: REG tx data reg2 */
#define MF_REG_TX_DATA_REG2 0x000000cc
/* [0xd0]: REG tx data reg3 */
#define MF_REG_TX_DATA_REG3 0x000000d0
/* [0xd4]: REG tx data reg4 */
#define MF_REG_TX_DATA_REG4 0x000000d4
/* [0xd8]: REG tx data reg5 */
#define MF_REG_TX_DATA_REG5 0x000000d8
/* [0xdc]: REG tx data reg6 */
#define MF_REG_TX_DATA_REG6 0x000000dc
/* [0xe0]: REG tx data reg7 */
#define MF_REG_TX_DATA_REG7 0x000000e0
/* [0xe4]: REG tx data reg8 */
#define MF_REG_TX_DATA_REG8 0x000000e4
/* [0xe8]: REG tx data reg9 */
#define MF_REG_TX_DATA_REG9 0x000000e8
/* [0xec]: REG tx data reg10 */
#define MF_REG_TX_DATA_REG10 0x000000ec
/* [0xf0]: REG tx data reg11 */
#define MF_REG_TX_DATA_REG11 0x000000f0
/* [0xf4]: REG tx data reg12 */
#define MF_REG_TX_DATA_REG12 0x000000f4
/* [0xf8]: REG tx data reg13 */
#define MF_REG_TX_DATA_REG13 0x000000f8
/* [0xfc]: REG tx data reg14 */
#define MF_REG_TX_DATA_REG14 0x000000fc
/* [0x100]: REG tx data reg15 */
#define MF_REG_TX_DATA_REG15 0x00000100
/* [0x104]: REG tx data reg16 */
#define MF_REG_TX_DATA_REG16 0x00000104
/* [0x108]: REG tx data reg17 */
#define MF_REG_TX_DATA_REG17 0x00000108
/* [0x10c]: REG tx data reg18 */
#define MF_REG_TX_DATA_REG18 0x0000010c
/* [0x110]: REG tx data reg19 */
#define MF_REG_TX_DATA_REG19 0x00000110
/* [0x114]: REG tx data reg20 */
#define MF_REG_TX_DATA_REG20 0x00000114
/* [0x118]: REG tx data reg21 */
#define MF_REG_TX_DATA_REG21 0x00000118
/* [0x11c]: REG tx data reg22 */
#define MF_REG_TX_DATA_REG22 0x0000011c
/* [0x120]: REG tx data reg23 */
#define MF_REG_TX_DATA_REG23 0x00000120
/* [0x124]: REG tx data reg24 */
#define MF_REG_TX_DATA_REG24 0x00000124
/* [0x128]: REG tx data reg25 */
#define MF_REG_TX_DATA_REG25 0x00000128
/* [0x12c]: REG tx data reg26 */
#define MF_REG_TX_DATA_REG26 0x0000012c
/* [0x130]: REG tx data reg27 */
#define MF_REG_TX_DATA_REG27 0x00000130
/* [0x134]: REG tx data reg28 */
#define MF_REG_TX_DATA_REG28 0x00000134
/* [0x138]: REG tx data reg29 */
#define MF_REG_TX_DATA_REG29 0x00000138
/* [0x13c]: REG tx data reg30 */
#define MF_REG_TX_DATA_REG30 0x0000013c
/* [0x140]: REG tx data reg31 */
#define MF_REG_TX_DATA_REG31 0x00000140
/* [0x144]: REG tx data reg32 */
#define MF_REG_TX_DATA_REG32 0x00000144
#endif
